unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TeEngine, Series, ExtCtrls, TeeProcs, Chart, StdCtrls, ExtDlgs, jpeg;

type
  TForm1 = class(TForm)
    Chart1: TChart;
    Series1: TLineSeries;
    Series2: TLineSeries;
    Series3: TLineSeries;
    Memo1: TMemo;
    Chart2: TChart;
    LineSeries1: TLineSeries;
    LineSeries2: TLineSeries;
    ListBox1: TListBox;
    Chart3: TChart;
    LineSeries3: TLineSeries;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ListBox1Click(Sender: TObject);


  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  MyPalette : TColorArray;
  faulttype : Integer;
  fault, fFound : Boolean;
  fType : Array of String;
  fOutput : Array of Integer;
  files : TStringList;
  opvarfault : Array[1..2593] of String;
  opvar :  Array[1..2593, 1..39] of Integer;
  max_a, max_a_b, max_a_c : Integer;
  max_b, max_b_a, max_b_c : Integer;
  z_a, z_a_b, z_a_c : Integer;
  z_b, z_b_a, z_b_c : Integer;
  z_c, z_c_a, z_c_b : Integer;
  z150_a, z150_a_b, z150_a_c : Integer;
  z150_b, z150_b_a, z150_b_c : Integer;
  z150_c, z150_c_a, z150_c_b : Integer;
  r1, r2 : Double;
  FaultI : Integer;

implementation

{$R *.dfm}

//----------------------------------------------------------------------------
// Uses 'FileCtrl' for SelectDirectory() function
//----------------------------------------------------------------------------
Procedure FindFiles(const Path, Mask:string; SubDir:Boolean; Files:TStringList );
var
  SearchRec : TSearchRec;
  sDir : String;
begin
  if FindFirst(Path + Mask, faAnyFile-faDirectory, SearchRec)=0 then
  begin
    repeat
      Files.Add(Path + searchRec.Name);
    until FindNext(searchRec) <> 0;
  end;

  if not SubDir then
  begin
    FindClose(SearchRec);
    Exit;
  end;

  sDir := IncludeTrailingPathDelimiter(Path);
  if FindFirst(Path + Mask, faDirectory, SearchRec)=0 then
  begin
    repeat
      if (SearchRec.Name <> '.') and (SearchRec.Name <> '..') then
      begin
        if SearchRec.Attr and faDirectory = faDirectory then
        begin
          FindFiles (sDir + SearchRec.Name + '\', Mask, SubDir, Files);
        end;
      end;

    until FindNext(searchRec) <> 0;
  end;
  FindClose(SearchRec);
end;

//---------------------------------------------------------------------------
Procedure FindFault();
var
  I : Integer;
  ft, fs : String;
  text : String;
  found : Boolean;
begin
  found := false;
  I := 0;

  while ( (I<2592) AND (found=false) ) do begin
    I := I + 1;
    if ((max_a>=opvar[I,1]-1) AND (max_a<=opvar[I,1]+1)) then begin
      if ((max_a_b>=opvar[I,2]-1) AND (max_a_b<=opvar[I,2]+1)) then begin
        if ((max_a_c>=opvar[I,3]-1) AND (max_a_c<=opvar[I,3]+1)) then begin
          if ((max_b>=opvar[I,4]-1) AND (max_b<=opvar[I,4]+1)) then begin
            if ((max_b_a>=opvar[I,5]-1) AND (max_b_a<=opvar[I,5]+1)) then begin
              if ((max_b_c>=opvar[I,6]-1) AND (max_b_c<=opvar[I,6]+1)) then begin
                if ((z_a>=opvar[I,7]-1) AND (z_a<=opvar[I,7]+1)) then begin
                  if ((z_a_b>=opvar[I,8]-1) AND (z_a_b<=opvar[I,8]+1)) then begin
                    if ((z_a_c>=opvar[I,9]-1) AND (z_a_c<=opvar[I,9]+1)) then begin
                      if ((z_b>=opvar[I,10]-1) AND (z_b<=opvar[I,10]+1)) then begin
                        if ((z_b_a>=opvar[I,11]-1) AND (z_b_a<=opvar[I,11]+1)) then begin
                          if ((z_b_c>=opvar[I,12]-1) AND (z_b_c<=opvar[I,12]+1)) then begin
                            if ((z_c>=opvar[I,13]-1) AND (z_c<=opvar[I,13]+1)) then begin
                              if ((z_c_a>=opvar[I,14]-1) AND (z_c_a<=opvar[I,14]+1)) then begin
                                if ((z_c_b>=opvar[I,15]-1) AND (z_c_b<=opvar[I,15]+1)) then begin
                                  if ((z150_a>=opvar[I,16]-1) AND (z150_a<=opvar[I,16]+1)) then begin
                                    if ((z150_a_b>=opvar[I,17]-1) AND (z150_a_b<=opvar[I,17]+1)) then begin
                                      if ((z150_a_c>=opvar[I,18]-1) AND (z150_a_c<=opvar[I,18]+1)) then begin
                                        if ((z150_b>=opvar[I,19]-1) AND (z150_b<=opvar[I,19]+1)) then begin
                                          if ((z150_b_a>=opvar[I,20]-1) AND (z150_b_a<=opvar[I,20]+1)) then begin
                                            if ((z150_b_c>=opvar[I,21]-1) AND (z150_b_c<=opvar[I,21]+1)) then begin
                                              if ((z150_c>=opvar[I,22]-1) AND (z150_c<=opvar[I,22]+1)) then begin
                                                if ((z150_c_a>=opvar[I,23]-1) AND (z150_c_a<=opvar[I,23]+1)) then begin
                                                  if ((z150_c_b>=opvar[I,24]-1) AND (z150_c_b<=opvar[I,24]+1)) then begin
                                                    text := opvarfault[I];
                                                    found := true;
                                                  end;
                                                end;
                                              end;
                                            end;
                                          end;
                                        end;
                                      end;
                                    end;
                                  end;
                                end;
                              end;
                            end;
                          end;
                        end;
                      end;
                    end;
                  end;
                end;
              end;
            end;
          end;
        end;
      end;
    end;
  end;

//  Form1.Memo1.Lines.Add(IntToStr(max_a) +' : '+ IntToStr(opvar[I,1]) );
//  Form1.Memo1.Lines.Add(IntToStr(max_a_b) +' : '+ IntToStr(opvar[I,2]) );
//  Form1.Memo1.Lines.Add(IntToStr(max_a_c) +' : '+ IntToStr(opvar[I,3]) );
//  Form1.Memo1.Lines.Add(IntToStr(max_b) +' : '+ IntToStr(opvar[I,4]) );
//  Form1.Memo1.Lines.Add(IntToStr(max_b_a) +' : '+ IntToStr(opvar[I,5]) );
//  Form1.Memo1.Lines.Add(IntToStr(max_b_c) +' : '+ IntToStr(opvar[I,6]) );
//  Form1.Memo1.Lines.Add(IntToStr(z_a) +' : '+ IntToStr(opvar[I,7]) );
//  Form1.Memo1.Lines.Add(IntToStr(z_a_b) +' : '+ IntToStr(opvar[I,8]) );
//  Form1.Memo1.Lines.Add(IntToStr(z_a_c) +' : '+ IntToStr(opvar[I,9]) );
//  Form1.Memo1.Lines.Add(IntToStr(z_b) +' : '+ IntToStr(opvar[I,10]) );
//  Form1.Memo1.Lines.Add(IntToStr(z_b_a) +' : '+ IntToStr(opvar[I,11]) );
//  Form1.Memo1.Lines.Add(IntToStr(z_b_c) +' : '+ IntToStr(opvar[I,12]) );
//  Form1.Memo1.Lines.Add(IntToStr(z_c) +' : '+ IntToStr(opvar[I,13]) );
//  Form1.Memo1.Lines.Add(IntToStr(z_c_a) +' : '+ IntToStr(opvar[I,14]) );
//  Form1.Memo1.Lines.Add(IntToStr(z_c_b) +' : '+ IntToStr(opvar[I,15]) );
//  Form1.Memo1.Lines.Add(IntToStr(z150_a) +' : '+ IntToStr(opvar[I,16]) );
//  Form1.Memo1.Lines.Add(IntToStr(z150_a_b) +' : '+ IntToStr(opvar[I,17]) );
//  Form1.Memo1.Lines.Add(IntToStr(z150_a_c) +' : '+ IntToStr(opvar[I,18]) );
//  Form1.Memo1.Lines.Add(IntToStr(z150_b) +' : '+ IntToStr(opvar[I,19]) );
//  Form1.Memo1.Lines.Add(IntToStr(z150_b_a) +' : '+ IntToStr(opvar[I,20]) );
//  Form1.Memo1.Lines.Add(IntToStr(z150_b_c) +' : '+ IntToStr(opvar[I,21]) );
//  Form1.Memo1.Lines.Add(IntToStr(z150_c) +' : '+ IntToStr(opvar[I,22]) );
//  Form1.Memo1.Lines.Add(IntToStr(z150_c_a) +' : '+ IntToStr(opvar[I,23]) );
//  Form1.Memo1.Lines.Add(IntToStr(z150_c_b) +' : '+ IntToStr(opvar[I,24]) );
//  Form1.Memo1.Lines.Add(IntToStr(I));
  I := LastDelimiter('-', text);
  ft := Copy(text, I-2, 2);
  fs := Copy(text, I+1, length(text)-I+1);
  if (ft='AG') then I :=1 ;
  if (ft='BG') then I :=2 ;
  if (ft='CG') then I :=3 ;

  if (fs='1km') then    I := 6+I;
  if (fs='2.5km') then  I := 6+I;
  if (fs='4km') then    I := 6+I;
  if (fs='6km') then    I := 3+I;
  if (fs='7.5km') then  I := 3+I;
  if (fs='9km') then    I := 3+I;
  if (fs='11km') then   I := I;
  if (fs='12.5km') then I := I;
  if (fs='14km') then   I := I;

  FaultI := I;

end;

//---------------------------------------------------------------------------
procedure TForm1.ListBox1Click(Sender: TObject);
var
  myFile : TextFile;
  path : string;
  text : string;
  time, a, b, c, i1, i2  : Double;
  fDetail : Array[1..20] of String;
  ftime : Double;
  grid : Boolean;
  ai, bi, ci : Integer;
  I, count : Integer;
  ft, fs : String;
  za, zb, zc, ca, cb, cc : Boolean;

begin
  text := ListBox1.Items[ListBox1.ItemIndex];
  path := Files.Strings[ListBox1.ItemIndex];
  Memo1.Clear;
  Memo1.Lines.Add('Tested Fault Case = '+ text);

  AssignFile(myFile, path);
  Reset(myFile);
  Chart1[0].Clear;
  Chart1[1].Clear;
  Chart1[2].Clear;
  Chart2[0].Clear;
  Chart2[1].Clear;
  Chart3[0].Clear;
  fault := false;
  fFound := false;
  count := 0;
  ftime := 0;
  za := false;
  zb := false;
  zc := false;
  ca := false;
  cb := false;
  cc := false;

  ReadLn(myFile, time, a, b, c, i1, i2);
  if(a<b) then begin
    grid := true;
  end
  else begin
    grid := false;
  end;

  if (grid) then begin
    ai := Round(b);
    bi := Round(a);
  end
  else begin
    ai := Round(a);
    bi := Round(b);
  end;
  ci := Round(c);

  max_a := ai;
  max_a_b := bi;
  max_a_c := ci;
  max_b := bi;
  max_b_a := ai;
  max_b_c := ci;
  z_a := 0;
  z_a_b := 0;
  z_a_c := 0;
  z_b := 0;
  z_b_a := 0;
  z_b_c := 0;
  z_c := 0;
  z_c_a := 0;
  z_c_b := 0;
  z150_a := 0;
  z150_a_b := 0;
  z150_a_c := 0;
  z150_b := 0;
  z150_b_a := 0;
  z150_b_c := 0;
  z150_c := 0;
  z150_c_a := 0;
  z150_c_b := 0;
  r1 := i1;
  r2 := i2;
  FaultI := 0;

  while not eof(myFile) do begin
    ReadLn(myFile, time, a, b, c, i1, i2);
    if (grid) then begin
      ai := Round(b);
      bi := Round(a);
    end
    else begin
      ai := Round(a);
      bi := Round(b);
    end;
    ci := Round(c);

    Chart1[0].AddXY(time, a);
    Chart1[1].AddXY(time, b);
    Chart1[2].AddXY(time, c);
    Chart2[0].AddXY(time, i1);
    Chart2[1].AddXY(time, i2);

    if (fault=false) then begin
      if (i1<1.0E-18) then begin
        Chart3[0].AddXY(time, 0);
      end
      else begin//i1>1.0E-18, fault detected by fault type unknown yet
        Chart3[0].AddXY(time, 12);
        fault := true;
      end;
    end
    else begin //fault occurs but Fault Type unknown yet
      count := count + 1;
      if (max_a<ai) then begin
          max_a   := ai;
          max_a_b := bi;
          max_a_c := ci;
        end;
        if (max_b<bi) then begin
          max_b   := bi;
          max_b_a := ai;
          max_b_c := ci;
        end;
        if (r1<i1) then begin
          r1 := i1;
        end;
        if (r2<i2) then begin
          r2 := i2;
        end;

        if( (ai>150) AND (ca=false) ) then begin
          z150_a   := ai;
          z150_a_b := bi;
          z150_a_c := ci ;
          ca := true;
        end;
        if( (bi>-150) AND (cb=false) ) then begin
          z150_b   := bi;
          z150_b_a := ai;
          z150_b_c := ci;
          cb := true;
        end;
        if( (ci>150) AND (cc=false) ) then begin
          z150_c   := ci;
          z150_c_a := ai;
          z150_c_b := bi;
          cc := true;
        end;

        if (ai<0) then begin
          z_a   := ai;
          z_a_b := bi;
          z_a_c := ci ;
        end;
        if (bi>0) then begin
          z_b   := bi;
          z_b_a := ai;
          z_b_c := ci;
        end;
        if (ci<0) then begin
          z_c   := ci;
          z_c_a := ai;
          z_c_b := bi;
        end;

      if ( (count>=38) AND (fFound=false) ) then begin //acquire anyway here
        ftime := time;
        fFound := true;
        FindFault();
      end;

      if (fFound=false) then begin
        if (ai<0) or (bi>0) or (ci<0) then begin
          ftime := time;
          fFound := true;
          FindFault();
          Chart3[0].AddXY(time, FaultI);
        end
        else begin
          Chart3[0].AddXY(time, 12);
        end;
      end
      else begin //Fault type KNOWN, constant output
        Chart3[0].AddXY(time, FaultI);
      end;

    end;

  end;
  CloseFile(myFile);

  fDetail[1] := 'C1 (AG at Section 1)';
  fDetail[2] := 'C2 (BG at Section 1)';
  fDetail[3] := 'C3 (CG at Section 1)';
  fDetail[4] := 'C4 (AG at Section 2)';
  fDetail[5] := 'C5 (BG at Section 2)';
  fDetail[6] := 'C6 (CG at Section 2)';
  fDetail[7] := 'C7 (AG at Section 3)';
  fDetail[8] := 'C8 (BG at Section 3)';
  fDetail[9] := 'C9 (CG at Section 3)';

  Memo1.Lines.Add('');
  Memo1.Lines.Add('Detected Fault Category = '+ fDetail[FaultI]);
  Memo1.Lines.Add('');
  Memo1.Lines.Add('Fault Detection Time = '+ FloatToStr(ftime) +'s');
  Memo1.Lines.Add('');

end;

//---------------------------------------------------------------------------
procedure TForm1.FormCreate(Sender: TObject);
var
  myFile : TextFile;
  path : string;
  text : string;
  I : Integer;
  count : Integer;
  input : TStringList;

begin
  SetLength(MyPalette, 5);
  MyPalette[0]:= clRed;
  MyPalette[1]:= clBlue;
  MyPalette[2]:= clBlack;
  MyPalette[3]:= clGreen;
  MyPalette[4]:= clNavy;
  SetDefaultColorPalette( MyPalette );

  SetLength(fType, 100);
  SetLength(fOutput, 100);

  Files := TStringList.Create;
  path := 'Data\';
  FindFiles(path, '*.*', true, Files);

  ListBox1.Clear;
  for I:=0 to Files.Count-1 do begin
    text := ExtractFileName(Files.Strings[I]);
    text := StringReplace(text, '.txt', '', [rfReplaceAll, rfIgnoreCase]);
    ListBox1.Items.Add(text);
  end;

  Memo1.Lines.Add('Loaded folder: '+ path);
  Memo1.Lines.Add('Total files: '+ IntToStr(Files.Count));

  AssignFile(myFile, 'Optimised_Variable.txt');
  Reset(myFile);

  input := TStringList.Create;
  count := 1;
  while not eof(myFile) do begin
    ReadLn(myfile, text);

    input.Delimiter := ' ';
    input.DelimitedText := text;

    opvarfault[count] := input[0];
    for I:=1 to 24 do begin
      opvar[count,I] := StrtoInt(input[I]);
    end;

    //Memo1.Lines.Add(IntToStr(count) +' '+ FloatToStr(opvar[count,1]));
    count := count + 1;
  end;
  CloseFile(myFile);
  input.Free;

end;

//---------------------------------------------------------------------------
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  MyPalette:= nil;
  Files.Free;
end;

//---------------------------------------------------------------------------
end.
